<?php
/*
LMB^Box Smileys -> Was WP Smileys
by Thomas Montague
http://aboutme.lmbbox.com/
A Clickable Smilies hack for WordPress. Add, edit, remove, and manage the display of your smileys!
Version 2.1, 2005-05-17

== Directions For Use ==

At the bottom half of this file, there will be standard html with a php call in the content div. You may edit 
the look and layout of this part anyway you see fit. To display the smileys, you must call: 

	if ($_GET['action'] == 'admin' && get_settings('use_smilies')) {
	// Admin Write Pages Smileys
		echo lmbbox_smileys($lmbbox_smileys_options['display_for_admin']);
	} elseif ($_GET['action'] == 'comment' && get_settings('use_smilies') && $lmbbox_smileys_options['display_smileys_in_comments']) {
	// Comment Form Smileys
		echo lmbbox_smileys($lmbbox_smileys_options['display_for_comment']);
	} else {
		echo 'Error: Smiley Page called incorrectly!';
	}

where you want the smileys to be on the page.

The smiles are returned in a table with a class of lmbbox_smileys_table. To set the styles for the page, go to the bottom 
half of this file and you will see in the <head></head> tags where the style is set (read on!). If you set in the LMB^Box 
Smileys Options Page to display the smileys with a title, the smileys will be returned with a <h1></h1> heading right 
before the table, else just the table is returned.


#### Styling the Smileys ####
To add styles to the Smileys Page, open the lmbbox-smileys-popup.php and go to the bottom half to the page. You will see some 
normal html code then a styles section. Add your styling there! Here's what's available:


****** Styling the Smileys Page ******
	If you wish to style the Smileys Page just add:

body {
	your style;
}
.lmbbox_smileys {
	your style;
}
.lmbbox_smileys h1 {  
	your style;
}
.lmbbox_smileys h2 {
	your style;
}
.lmbbox_smileys_table {
	your style;
}
.lmbbox_smileys_table tr, .lmbbox_smileys_table td, .lmbbox_smileys_table img {
	your style;
}


== End of Directions For Use ==
*/

// LMB^Box Smileys Popup Display Page
// call {root}/config.php
// neat little test to find the wp-config.php file in the root directory
// from Owen Winkler's Exhibit http://www.asymptomatic.net/wp-hacks/
$config_file = 'wp-config.php';
$c = 0;
while(!is_file($config_file)) {
	$config_file = '../' . $config_file;
	$c++;
	if($c == 15)
		exit('Could not find wp-config.php!');
}
require_once($config_file);

// function to get smileys output
function lmbbox_get_smileys($smileys, $path, $url, $disabled, $disabled_prefix, $disabled_default) {
	$output = '';
	$smiled = array();
	$i = 0;
	foreach ($smileys as $tag => $img) {
		if (!in_array($img, $smiled) && !$disabled[$img]) {
			$smiled[] = $img;
			$tag = str_replace(' ', '', $tag);
			if ($i == 0) {
				$output .= 	'<tr>
								<td><img src="' . $url . $img . '" alt="'. $tag .'" onclick="smileys(\''. $tag .'\');"/></td>
							';
				$i++;
			} elseif ($i > 0 && $i < 6) {
				$output .= 	'	<td><img src="' . $url . $img . '" alt="'. $tag .'" onclick="smileys(\''. $tag .'\');"/></td>
							';
				$i++;
			} elseif ($i == 6) {
				$output .= 	'	<td><img src="' . $url . $img . '" alt="'. $tag .'" onclick="smileys(\''. $tag .'\');"/></td>
							</tr>
							';
				$i = 0;
			}
		} elseif (!in_array($img, $smiled) && $disabled[$img]) {
			$smiled[] = $img;
			$tag = str_replace(' ', '', $tag);
			if (file_exists($path . $disabled_prefix . $img)) {
				if ($i == 0) {
					$output .= 	'<tr>
									<td><img src="' . $url . $disabled_prefix . $img . '" alt="'. $tag .'" /></td>
								';
					$i++;
				} elseif ($i > 0 && $i < 6) {
					$output .= 	'	<td><img src="' . $url . $disabled_prefix . $img . '" alt="'. $tag .'" /></td>
								';
					$i++;
				} elseif ($i == 6) {
					$output .= 	'	<td><img src="' . $url . $disabled_prefix . $img . '" alt="'. $tag .'" /></td>
								</tr>
								';
					$i = 0;
				}
			} else {
				if ($i == 0) {
					$output .= 	'<tr>
									<td><img src="' . $url . $disabled_default . '" alt="'. $tag .'" /></td>
								';
					$i++;
				} elseif ($i > 0 && $i < 6) {
					$output .= 	'	<td><img src="' . $url . $disabled_default . '" alt="'. $tag .'" /></td>
								';
					$i++;
				} elseif ($i == 6) {
					$output .= 	'	<td><img src="' . $url . $disabled_default . '" alt="'. $tag .'" /></td>
								</tr>
								';
					$i = 0;
				}
			} // End if disabled file_exists
		} // End if !in_array
	} // End foreach
	return $output;
}

// function to start WP Smileys!
function lmbbox_smileys($which_smileys) {
	global $lmbbox_smileys_manage;
	$results = '';
	foreach ($which_smileys as $smileys => $display) {
		if ($display == 0) {
			continue;
		} elseif ($display == 1) {
			$temp = lmbbox_get_smileys($lmbbox_smileys_manage['smileys_list'][$smileys]['smileys'], $lmbbox_smileys_manage['smileys_path'], $lmbbox_smileys_manage['smileys_url_path'], $lmbbox_smileys_manage['smileys_list'][$smileys]['disabled'], $lmbbox_smileys_manage['smileys_disabled_prefix'], $lmbbox_smileys_manage['smileys_disabled_default']);
			$results .= '<h1>' . $lmbbox_smileys_manage['smileys_list'][$smileys]['title'] . '</h1>
						<table class="lmbbox_smileys_table">' . $temp . '</table>';
		} elseif ($display == 2) {
			$temp = lmbbox_get_smileys($lmbbox_smileys_manage['smileys_list'][$smileys]['smileys'], $lmbbox_smileys_manage['smileys_path'], $lmbbox_smileys_manage['smileys_url_path'], $lmbbox_smileys_manage['smileys_list'][$smileys]['disabled'], $lmbbox_smileys_manage['smileys_disabled_prefix'], $lmbbox_smileys_manage['smileys_disabled_default']);
			$results .= '<table class="lmbbox_smileys_table">' . $temp . '</table>';
		} else {
			continue;
		}
	}
	if ($results) {
		return $results;
	} else {
		return 'No Smileys Avalible! Contact the Admin to Activate the Smileys!';
	}
}

// Start Page with Smiley JS
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>LMB^Box Smileys 2.1 for WordPress</title>
<script language="JavaScript" type="text/javascript">
<!--
function smileys(tag) {
	var my_field;
	if (window.opener.document.getElementById('content') && window.opener.document.getElementById('content').type == 'textarea') {
		my_field = window.opener.document.getElementById('content');
	}
	else if (window.opener.document.getElementById('comment') && window.opener.document.getElementById('comment').type == 'textarea') {
		my_field = window.opener.document.getElementById('comment');
	}
	else {
		return false;
	}
	if (document.selection) {
		my_field.focus();
		sel = window.opener.document.selection.createRange();
		sel.text = tag;
		my_field.focus();
	}
	else if (my_field.selectionStart || my_field.selectionStart == '0') {
		var startPos = my_field.selectionStart;
		var endPos = my_field.selectionEnd;
		var cursorPos = endPos;
		my_field.value = my_field.value.substring(0, startPos)
					  + tag
					  + my_field.value.substring(endPos, my_field.value.length);
		cursorPos += tag.length;
		my_field.focus();
		my_field.selectionStart = cursorPos;
		my_field.selectionEnd = cursorPos;
	}
	else {
		my_field.value += tag;
		my_field.focus();
	}
}
//-->
</script>
<style type="text/css">
/* Body style for Smileys Page */
body {
	font-family:       Verdana, Geneva, Tahoma, Trebuchet MS, Arial, Sans-serif;
	font-size:         11px;
	color:             #000000;
	background-color:  #FFFFFF;
}
/* Main Div for Smileys Page */
.lmbbox_smileys {
	/* your style; */
}
/* <h1> style -> used for Smileys Heading */
.lmbbox_smileys h1 {  
	font-family:       Verdana, Geneva, Tahoma, Trebuchet MS, Arial, Sans-serif;
	font-size:         14px;
	font-weight:       bold;
	color:             #000000;
}
/* <h2> style -> used for Main Page Heading */
.lmbbox_smileys h2 {
	/* your style; */
}
/* Main Table for Smileys Output */
.lmbbox_smileys_table {
	/* your style; */
}
/* And anything under the table */
.lmbbox_smileys_table tr, .lmbbox_smileys_table td, .lmbbox_smileys_table img {
	/* your style; */
}
</style>
</head>
<body>
<div class="lmbbox_smileys">
  <h2>LMB^Box Smileys 2.1 for WordPress</h2>
<?php
if ($_GET['action'] == 'admin' && get_settings('use_smilies')) {
// Admin Write Pages Smileys
	echo lmbbox_smileys($lmbbox_smileys_options['display_for_admin']);
} elseif ($_GET['action'] == 'comment' && get_settings('use_smilies') && $lmbbox_smileys_options['display_smileys_in_comments']) {
// Comment Form Smileys
	echo lmbbox_smileys($lmbbox_smileys_options['display_for_comment']);
} else {
	echo 'Error: Smiley Page called incorrectly!';
}
?>
</div>
</body>
</html>
